Index: Core/Util/Util.cs
===================================================================
--- Core/Util/Util.cs	(revision 27031)
+++ Core/Util/Util.cs	(working copy)
@@ -2800,15 +2800,18 @@
 
     private static HashSet<string> GetUniqueTopLevelFolders()
     {
-      HashSet<string> uniqueTopLevelFolders = new HashSet<string>();
-
       HashSet<string> foldersLookedUpCopy = null;
+
       lock (_foldersLookedUpLock)
       {
         foldersLookedUpCopy = new HashSet<string>(_foldersLookedUp);
       }
 
-      foreach (string dir in foldersLookedUpCopy)
+      ArrayList arrayList = new ArrayList(foldersLookedUpCopy.ToArray());
+
+      arrayList.Sort();
+
+      foreach(string dir in arrayList)
       {
         if (string.IsNullOrEmpty(dir))
         {
@@ -2816,91 +2819,23 @@
         }
         if (Path.IsPathRooted(dir))
         {
+          string parentDir = GetParentDirectory(dir);
 
-          string parentDir2Use = dir;
-          string parentDir = dir;
-          int nrOfFoldersOnParentDirOld = 0;
-          while (true)
+          if (!string.IsNullOrEmpty(parentDir))
           {
-            parentDir = GetParentDirectory(parentDir);
-
-            if (string.IsNullOrEmpty(parentDir))
+            if (foldersLookedUpCopy.Count(fli => fli.StartsWith(parentDir)) > 1)
             {
-              break;
+              foldersLookedUpCopy.RemoveWhere(element => element.StartsWith(parentDir));
+              foldersLookedUpCopy.Add(parentDir);
             }
-
-            bool isPathRoot = IsPathRoot(parentDir);
-
-            if (isPathRoot)
-            {
-              break;
-            }
-            
-            if (!uniqueTopLevelFolders.Contains(parentDir))
-            {
-              int nrOfFoldersOnParentDir = foldersLookedUpCopy.Count(fli => fli.StartsWith(parentDir));
-
-              if (nrOfFoldersOnParentDir == 1)
-              {
-                break;
-              }
-
-              if (nrOfFoldersOnParentDirOld == nrOfFoldersOnParentDir)
-              {
-                break;
-              }
-              if (nrOfFoldersOnParentDir > 0)
-              {
-                parentDir2Use = parentDir;                
-              }
-              nrOfFoldersOnParentDirOld = nrOfFoldersOnParentDir;
-            }     
-            else
-            {
-              parentDir2Use = null;
-              break;
-            }
           }
-
-          if (parentDir2Use != null && !uniqueTopLevelFolders.Contains(parentDir2Use))
-          {
-            string folderCompare = parentDir2Use;
-            bool addFolder = true;
-            if (uniqueTopLevelFolders.Count > 0)
-            {
-              while (true)
-              {
-                int itemsCount =
-                  uniqueTopLevelFolders.Count(fli => fli.StartsWith(folderCompare));
-                if (itemsCount > 0)
-                {
-                  addFolder = false;
-                  break;
-                }
-               
-                folderCompare = GetParentDirectory(folderCompare);
-
-                if (string.IsNullOrEmpty(folderCompare))
-                {
-                  break;
-                }
-
-                bool isPathRoot = IsPathRoot(folderCompare);
-                if (isPathRoot)
-                {
-                  break;
-                }
-              }
-            }
-            if (addFolder)
-            {
-              uniqueTopLevelFolders.Add(parentDir2Use);    
-            }            
-          }          
         }
+        else
+        {
+          foldersLookedUpCopy.RemoveWhere(element => element.Contains(dir));
+        }
       }
-
-      return uniqueTopLevelFolders;
+      return foldersLookedUpCopy;
     }
 
     private static bool IsPathRoot(string dir)
